// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/LocationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'event_speed'
#include "etsi_its_denm_msgs/msg/detail/speed__struct.hpp"
// Member 'event_position_heading'
#include "etsi_its_denm_msgs/msg/detail/heading__struct.hpp"
// Member 'traces'
#include "etsi_its_denm_msgs/msg/detail/traces__struct.hpp"
// Member 'road_type'
#include "etsi_its_denm_msgs/msg/detail/road_type__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__LocationContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__LocationContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LocationContainer_
{
  using Type = LocationContainer_<ContainerAllocator>;

  explicit LocationContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : event_speed(_init),
    event_position_heading(_init),
    traces(_init),
    road_type(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->event_speed_is_present = false;
      this->event_position_heading_is_present = false;
      this->road_type_is_present = false;
    }
  }

  explicit LocationContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : event_speed(_alloc, _init),
    event_position_heading(_alloc, _init),
    traces(_alloc, _init),
    road_type(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->event_speed_is_present = false;
      this->event_position_heading_is_present = false;
      this->road_type_is_present = false;
    }
  }

  // field types and members
  using _event_speed_type =
    etsi_its_denm_msgs::msg::Speed_<ContainerAllocator>;
  _event_speed_type event_speed;
  using _event_speed_is_present_type =
    bool;
  _event_speed_is_present_type event_speed_is_present;
  using _event_position_heading_type =
    etsi_its_denm_msgs::msg::Heading_<ContainerAllocator>;
  _event_position_heading_type event_position_heading;
  using _event_position_heading_is_present_type =
    bool;
  _event_position_heading_is_present_type event_position_heading_is_present;
  using _traces_type =
    etsi_its_denm_msgs::msg::Traces_<ContainerAllocator>;
  _traces_type traces;
  using _road_type_type =
    etsi_its_denm_msgs::msg::RoadType_<ContainerAllocator>;
  _road_type_type road_type;
  using _road_type_is_present_type =
    bool;
  _road_type_is_present_type road_type_is_present;

  // setters for named parameter idiom
  Type & set__event_speed(
    const etsi_its_denm_msgs::msg::Speed_<ContainerAllocator> & _arg)
  {
    this->event_speed = _arg;
    return *this;
  }
  Type & set__event_speed_is_present(
    const bool & _arg)
  {
    this->event_speed_is_present = _arg;
    return *this;
  }
  Type & set__event_position_heading(
    const etsi_its_denm_msgs::msg::Heading_<ContainerAllocator> & _arg)
  {
    this->event_position_heading = _arg;
    return *this;
  }
  Type & set__event_position_heading_is_present(
    const bool & _arg)
  {
    this->event_position_heading_is_present = _arg;
    return *this;
  }
  Type & set__traces(
    const etsi_its_denm_msgs::msg::Traces_<ContainerAllocator> & _arg)
  {
    this->traces = _arg;
    return *this;
  }
  Type & set__road_type(
    const etsi_its_denm_msgs::msg::RoadType_<ContainerAllocator> & _arg)
  {
    this->road_type = _arg;
    return *this;
  }
  Type & set__road_type_is_present(
    const bool & _arg)
  {
    this->road_type_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__LocationContainer
    std::shared_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__LocationContainer
    std::shared_ptr<etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LocationContainer_ & other) const
  {
    if (this->event_speed != other.event_speed) {
      return false;
    }
    if (this->event_speed_is_present != other.event_speed_is_present) {
      return false;
    }
    if (this->event_position_heading != other.event_position_heading) {
      return false;
    }
    if (this->event_position_heading_is_present != other.event_position_heading_is_present) {
      return false;
    }
    if (this->traces != other.traces) {
      return false;
    }
    if (this->road_type != other.road_type) {
      return false;
    }
    if (this->road_type_is_present != other.road_type_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const LocationContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LocationContainer_

// alias to use template instance with default allocator
using LocationContainer =
  etsi_its_denm_msgs::msg::LocationContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_HPP_
