// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_msgs:msg/AlacarteContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_msgs/msg/detail/alacarte_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `lane_position`
#include "etsi_its_denm_msgs/msg/detail/lane_position__functions.h"
// Member `impact_reduction`
#include "etsi_its_denm_msgs/msg/detail/impact_reduction_container__functions.h"
// Member `external_temperature`
#include "etsi_its_denm_msgs/msg/detail/temperature__functions.h"
// Member `road_works`
#include "etsi_its_denm_msgs/msg/detail/road_works_container_extended__functions.h"
// Member `positioning_solution`
#include "etsi_its_denm_msgs/msg/detail/positioning_solution_type__functions.h"
// Member `stationary_vehicle`
#include "etsi_its_denm_msgs/msg/detail/stationary_vehicle_container__functions.h"

bool
etsi_its_denm_msgs__msg__AlacarteContainer__init(etsi_its_denm_msgs__msg__AlacarteContainer * msg)
{
  if (!msg) {
    return false;
  }
  // lane_position
  if (!etsi_its_denm_msgs__msg__LanePosition__init(&msg->lane_position)) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
    return false;
  }
  // lane_position_is_present
  // impact_reduction
  if (!etsi_its_denm_msgs__msg__ImpactReductionContainer__init(&msg->impact_reduction)) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
    return false;
  }
  // impact_reduction_is_present
  // external_temperature
  if (!etsi_its_denm_msgs__msg__Temperature__init(&msg->external_temperature)) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
    return false;
  }
  // external_temperature_is_present
  // road_works
  if (!etsi_its_denm_msgs__msg__RoadWorksContainerExtended__init(&msg->road_works)) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
    return false;
  }
  // road_works_is_present
  // positioning_solution
  if (!etsi_its_denm_msgs__msg__PositioningSolutionType__init(&msg->positioning_solution)) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
    return false;
  }
  // positioning_solution_is_present
  // stationary_vehicle
  if (!etsi_its_denm_msgs__msg__StationaryVehicleContainer__init(&msg->stationary_vehicle)) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
    return false;
  }
  // stationary_vehicle_is_present
  return true;
}

void
etsi_its_denm_msgs__msg__AlacarteContainer__fini(etsi_its_denm_msgs__msg__AlacarteContainer * msg)
{
  if (!msg) {
    return;
  }
  // lane_position
  etsi_its_denm_msgs__msg__LanePosition__fini(&msg->lane_position);
  // lane_position_is_present
  // impact_reduction
  etsi_its_denm_msgs__msg__ImpactReductionContainer__fini(&msg->impact_reduction);
  // impact_reduction_is_present
  // external_temperature
  etsi_its_denm_msgs__msg__Temperature__fini(&msg->external_temperature);
  // external_temperature_is_present
  // road_works
  etsi_its_denm_msgs__msg__RoadWorksContainerExtended__fini(&msg->road_works);
  // road_works_is_present
  // positioning_solution
  etsi_its_denm_msgs__msg__PositioningSolutionType__fini(&msg->positioning_solution);
  // positioning_solution_is_present
  // stationary_vehicle
  etsi_its_denm_msgs__msg__StationaryVehicleContainer__fini(&msg->stationary_vehicle);
  // stationary_vehicle_is_present
}

bool
etsi_its_denm_msgs__msg__AlacarteContainer__are_equal(const etsi_its_denm_msgs__msg__AlacarteContainer * lhs, const etsi_its_denm_msgs__msg__AlacarteContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // lane_position
  if (!etsi_its_denm_msgs__msg__LanePosition__are_equal(
      &(lhs->lane_position), &(rhs->lane_position)))
  {
    return false;
  }
  // lane_position_is_present
  if (lhs->lane_position_is_present != rhs->lane_position_is_present) {
    return false;
  }
  // impact_reduction
  if (!etsi_its_denm_msgs__msg__ImpactReductionContainer__are_equal(
      &(lhs->impact_reduction), &(rhs->impact_reduction)))
  {
    return false;
  }
  // impact_reduction_is_present
  if (lhs->impact_reduction_is_present != rhs->impact_reduction_is_present) {
    return false;
  }
  // external_temperature
  if (!etsi_its_denm_msgs__msg__Temperature__are_equal(
      &(lhs->external_temperature), &(rhs->external_temperature)))
  {
    return false;
  }
  // external_temperature_is_present
  if (lhs->external_temperature_is_present != rhs->external_temperature_is_present) {
    return false;
  }
  // road_works
  if (!etsi_its_denm_msgs__msg__RoadWorksContainerExtended__are_equal(
      &(lhs->road_works), &(rhs->road_works)))
  {
    return false;
  }
  // road_works_is_present
  if (lhs->road_works_is_present != rhs->road_works_is_present) {
    return false;
  }
  // positioning_solution
  if (!etsi_its_denm_msgs__msg__PositioningSolutionType__are_equal(
      &(lhs->positioning_solution), &(rhs->positioning_solution)))
  {
    return false;
  }
  // positioning_solution_is_present
  if (lhs->positioning_solution_is_present != rhs->positioning_solution_is_present) {
    return false;
  }
  // stationary_vehicle
  if (!etsi_its_denm_msgs__msg__StationaryVehicleContainer__are_equal(
      &(lhs->stationary_vehicle), &(rhs->stationary_vehicle)))
  {
    return false;
  }
  // stationary_vehicle_is_present
  if (lhs->stationary_vehicle_is_present != rhs->stationary_vehicle_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_msgs__msg__AlacarteContainer__copy(
  const etsi_its_denm_msgs__msg__AlacarteContainer * input,
  etsi_its_denm_msgs__msg__AlacarteContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // lane_position
  if (!etsi_its_denm_msgs__msg__LanePosition__copy(
      &(input->lane_position), &(output->lane_position)))
  {
    return false;
  }
  // lane_position_is_present
  output->lane_position_is_present = input->lane_position_is_present;
  // impact_reduction
  if (!etsi_its_denm_msgs__msg__ImpactReductionContainer__copy(
      &(input->impact_reduction), &(output->impact_reduction)))
  {
    return false;
  }
  // impact_reduction_is_present
  output->impact_reduction_is_present = input->impact_reduction_is_present;
  // external_temperature
  if (!etsi_its_denm_msgs__msg__Temperature__copy(
      &(input->external_temperature), &(output->external_temperature)))
  {
    return false;
  }
  // external_temperature_is_present
  output->external_temperature_is_present = input->external_temperature_is_present;
  // road_works
  if (!etsi_its_denm_msgs__msg__RoadWorksContainerExtended__copy(
      &(input->road_works), &(output->road_works)))
  {
    return false;
  }
  // road_works_is_present
  output->road_works_is_present = input->road_works_is_present;
  // positioning_solution
  if (!etsi_its_denm_msgs__msg__PositioningSolutionType__copy(
      &(input->positioning_solution), &(output->positioning_solution)))
  {
    return false;
  }
  // positioning_solution_is_present
  output->positioning_solution_is_present = input->positioning_solution_is_present;
  // stationary_vehicle
  if (!etsi_its_denm_msgs__msg__StationaryVehicleContainer__copy(
      &(input->stationary_vehicle), &(output->stationary_vehicle)))
  {
    return false;
  }
  // stationary_vehicle_is_present
  output->stationary_vehicle_is_present = input->stationary_vehicle_is_present;
  return true;
}

etsi_its_denm_msgs__msg__AlacarteContainer *
etsi_its_denm_msgs__msg__AlacarteContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__AlacarteContainer * msg = (etsi_its_denm_msgs__msg__AlacarteContainer *)allocator.allocate(sizeof(etsi_its_denm_msgs__msg__AlacarteContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_msgs__msg__AlacarteContainer));
  bool success = etsi_its_denm_msgs__msg__AlacarteContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_msgs__msg__AlacarteContainer__destroy(etsi_its_denm_msgs__msg__AlacarteContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_msgs__msg__AlacarteContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__init(etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__AlacarteContainer * data = NULL;

  if (size) {
    data = (etsi_its_denm_msgs__msg__AlacarteContainer *)allocator.zero_allocate(size, sizeof(etsi_its_denm_msgs__msg__AlacarteContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_msgs__msg__AlacarteContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_msgs__msg__AlacarteContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__fini(etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_msgs__msg__AlacarteContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_msgs__msg__AlacarteContainer__Sequence *
etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * array = (etsi_its_denm_msgs__msg__AlacarteContainer__Sequence *)allocator.allocate(sizeof(etsi_its_denm_msgs__msg__AlacarteContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__destroy(etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__are_equal(const etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * lhs, const etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_msgs__msg__AlacarteContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_msgs__msg__AlacarteContainer__Sequence__copy(
  const etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * input,
  etsi_its_denm_msgs__msg__AlacarteContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_msgs__msg__AlacarteContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_msgs__msg__AlacarteContainer * data =
      (etsi_its_denm_msgs__msg__AlacarteContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_msgs__msg__AlacarteContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_msgs__msg__AlacarteContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_msgs__msg__AlacarteContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
