// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/EnergyStorageType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ENERGY_STORAGE_TYPE__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ENERGY_STORAGE_TYPE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__EnergyStorageType __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__EnergyStorageType __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EnergyStorageType_
{
  using Type = EnergyStorageType_<ContainerAllocator>;

  explicit EnergyStorageType_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  explicit EnergyStorageType_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  // field types and members
  using _value_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _value_type value;
  using _bits_unused_type =
    uint8_t;
  _bits_unused_type bits_unused;

  // setters for named parameter idiom
  Type & set__value(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__bits_unused(
    const uint8_t & _arg)
  {
    this->bits_unused = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t SIZE_BITS =
    7u;
  static constexpr uint8_t BIT_INDEX_HYDROGEN_STORAGE =
    0u;
  static constexpr uint8_t BIT_INDEX_ELECTRIC_ENERGY_STORAGE =
    1u;
  static constexpr uint8_t BIT_INDEX_LIQUID_PROPANE_GAS =
    2u;
  static constexpr uint8_t BIT_INDEX_COMPRESSED_NATURAL_GAS =
    3u;
  static constexpr uint8_t BIT_INDEX_DIESEL =
    4u;
  static constexpr uint8_t BIT_INDEX_GASOLINE =
    5u;
  static constexpr uint8_t BIT_INDEX_AMMONIA =
    6u;

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__EnergyStorageType
    std::shared_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__EnergyStorageType
    std::shared_ptr<etsi_its_denm_msgs::msg::EnergyStorageType_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EnergyStorageType_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    if (this->bits_unused != other.bits_unused) {
      return false;
    }
    return true;
  }
  bool operator!=(const EnergyStorageType_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EnergyStorageType_

// alias to use template instance with default allocator
using EnergyStorageType =
  etsi_its_denm_msgs::msg::EnergyStorageType_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_HYDROGEN_STORAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_ELECTRIC_ENERGY_STORAGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_LIQUID_PROPANE_GAS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_COMPRESSED_NATURAL_GAS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_DIESEL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_GASOLINE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t EnergyStorageType_<ContainerAllocator>::BIT_INDEX_AMMONIA;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ENERGY_STORAGE_TYPE__STRUCT_HPP_
