// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_msgs:msg/LocationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__LOCATION_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__LOCATION_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_msgs/msg/detail/location_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'event_speed'
#include "etsi_its_denm_msgs/msg/detail/speed__traits.hpp"
// Member 'event_position_heading'
#include "etsi_its_denm_msgs/msg/detail/heading__traits.hpp"
// Member 'traces'
#include "etsi_its_denm_msgs/msg/detail/traces__traits.hpp"
// Member 'road_type'
#include "etsi_its_denm_msgs/msg/detail/road_type__traits.hpp"

namespace etsi_its_denm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LocationContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: event_speed
  {
    out << "event_speed: ";
    to_flow_style_yaml(msg.event_speed, out);
    out << ", ";
  }

  // member: event_speed_is_present
  {
    out << "event_speed_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_speed_is_present, out);
    out << ", ";
  }

  // member: event_position_heading
  {
    out << "event_position_heading: ";
    to_flow_style_yaml(msg.event_position_heading, out);
    out << ", ";
  }

  // member: event_position_heading_is_present
  {
    out << "event_position_heading_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_position_heading_is_present, out);
    out << ", ";
  }

  // member: traces
  {
    out << "traces: ";
    to_flow_style_yaml(msg.traces, out);
    out << ", ";
  }

  // member: road_type
  {
    out << "road_type: ";
    to_flow_style_yaml(msg.road_type, out);
    out << ", ";
  }

  // member: road_type_is_present
  {
    out << "road_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_type_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LocationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: event_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_speed:\n";
    to_block_style_yaml(msg.event_speed, out, indentation + 2);
  }

  // member: event_speed_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_speed_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_speed_is_present, out);
    out << "\n";
  }

  // member: event_position_heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_position_heading:\n";
    to_block_style_yaml(msg.event_position_heading, out, indentation + 2);
  }

  // member: event_position_heading_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_position_heading_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_position_heading_is_present, out);
    out << "\n";
  }

  // member: traces
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "traces:\n";
    to_block_style_yaml(msg.traces, out, indentation + 2);
  }

  // member: road_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_type:\n";
    to_block_style_yaml(msg.road_type, out, indentation + 2);
  }

  // member: road_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_type_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LocationContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_msgs::msg::LocationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_msgs::msg::LocationContainer & msg)
{
  return etsi_its_denm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_msgs::msg::LocationContainer>()
{
  return "etsi_its_denm_msgs::msg::LocationContainer";
}

template<>
inline const char * name<etsi_its_denm_msgs::msg::LocationContainer>()
{
  return "etsi_its_denm_msgs/msg/LocationContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_msgs::msg::LocationContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_msgs::msg::Heading>::value && has_fixed_size<etsi_its_denm_msgs::msg::RoadType>::value && has_fixed_size<etsi_its_denm_msgs::msg::Speed>::value && has_fixed_size<etsi_its_denm_msgs::msg::Traces>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_msgs::msg::LocationContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_msgs::msg::Heading>::value && has_bounded_size<etsi_its_denm_msgs::msg::RoadType>::value && has_bounded_size<etsi_its_denm_msgs::msg::Speed>::value && has_bounded_size<etsi_its_denm_msgs::msg::Traces>::value> {};

template<>
struct is_message<etsi_its_denm_msgs::msg::LocationContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__LOCATION_CONTAINER__TRAITS_HPP_
